// ==============================================================
// RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
// Version: 2022.1
// Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="cache_module_cache_module,hls_ip_2022_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg400-1,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=7.793600,HLS_SYN_LAT=18,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=301,HLS_SYN_LUT=823,HLS_VERSION=2022_1}" *)

module cache_module (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        address,
        dirty,
        dirty_ap_vld,
        hit,
        hit_ap_vld,
        data,
        data_ap_vld,
        updateSet,
        updateWay,
        newTag,
        updateTagValid,
        newData_address0,
        newData_ce0,
        newData_q0,
        updateDataValid
);

parameter    ap_ST_fsm_state1 = 9'd1;
parameter    ap_ST_fsm_state2 = 9'd2;
parameter    ap_ST_fsm_state3 = 9'd4;
parameter    ap_ST_fsm_state4 = 9'd8;
parameter    ap_ST_fsm_state5 = 9'd16;
parameter    ap_ST_fsm_state6 = 9'd32;
parameter    ap_ST_fsm_state7 = 9'd64;
parameter    ap_ST_fsm_state8 = 9'd128;
parameter    ap_ST_fsm_state9 = 9'd256;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [31:0] address;
output   dirty;
output   dirty_ap_vld;
output   hit;
output   hit_ap_vld;
output  [7:0] data;
output   data_ap_vld;
input  [7:0] updateSet;
input  [7:0] updateWay;
input  [31:0] newTag;
input   updateTagValid;
output  [1:0] newData_address0;
output   newData_ce0;
input  [7:0] newData_q0;
input   updateDataValid;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg dirty_ap_vld;
reg hit;
reg hit_ap_vld;
reg data_ap_vld;

(* fsm_encoding = "none" *) reg   [8:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg   [2:0] cacheMemory_address0;
reg    cacheMemory_ce0;
reg   [7:0] cacheMemory_we0;
reg   [63:0] cacheMemory_d0;
wire   [63:0] cacheMemory_q0;
wire   [0:0] updateDataValid_read_read_fu_114_p2;
wire   [0:0] updateTagValid_read_read_fu_120_p2;
wire   [28:0] trunc_ln7_fu_212_p1;
reg   [28:0] trunc_ln7_reg_458;
wire   [5:0] add_ln9_fu_240_p2;
reg   [5:0] add_ln9_reg_463;
reg   [2:0] cacheMemory_addr_reg_468;
wire   [5:0] or_ln11_fu_290_p2;
reg   [5:0] or_ln11_reg_473;
wire    ap_CS_fsm_state3;
reg   [2:0] lshr_ln1_reg_478;
wire    ap_CS_fsm_state4;
wire   [28:0] trunc_ln15_2_fu_334_p1;
reg   [28:0] trunc_ln15_2_reg_483;
reg   [2:0] cacheMemory_addr_1_reg_488;
wire    ap_CS_fsm_state5;
reg   [0:0] tmp_2_reg_493;
wire    ap_CS_fsm_state7;
wire   [0:0] grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return;
reg   [0:0] targetBlock_reg_498;
wire    ap_CS_fsm_state8;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_idle;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready;
wire   [1:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0;
wire   [2:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0;
wire   [7:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0;
wire   [63:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_idle;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready;
wire   [63:0] grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld;
wire   [2:0] grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0;
reg    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg;
reg    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg;
reg   [63:0] cacheMemory_load_2_loc_fu_110;
wire   [63:0] zext_ln9_fu_256_p1;
wire   [63:0] zext_ln15_fu_337_p1;
wire    ap_CS_fsm_state9;
wire    ap_CS_fsm_state2;
wire   [63:0] zext_ln10_fu_285_p1;
wire    ap_CS_fsm_state6;
wire   [63:0] zext_ln17_fu_364_p1;
wire   [0:0] trunc_ln9_fu_216_p1;
wire   [2:0] trunc_ln9_1_fu_228_p1;
wire   [5:0] shl_ln9_1_fu_232_p3;
wire   [5:0] shl_ln9_fu_220_p3;
wire   [2:0] lshr_ln9_fu_246_p4;
wire   [29:0] tmp_3_fu_261_p4;
wire   [31:0] and_ln_fu_271_p3;
wire   [31:0] or_ln10_fu_279_p2;
wire   [0:0] trunc_ln15_fu_296_p1;
wire   [2:0] trunc_ln15_1_fu_307_p1;
wire   [5:0] shl_ln15_2_fu_310_p3;
wire   [5:0] shl_ln15_1_fu_299_p3;
wire   [5:0] add_ln15_fu_318_p2;
wire   [0:0] tmp_1_fu_341_p3;
wire   [31:0] tmp_fu_349_p4;
wire   [31:0] or_ln16_fu_358_p2;
wire   [1:0] tmp_9_fu_380_p4;
wire   [5:0] zext_ln23_cast_fu_389_p4;
wire   [63:0] zext_ln23_fu_399_p1;
wire   [63:0] lshr_ln23_fu_403_p2;
reg   [8:0] ap_NS_fsm;
reg    ap_ST_fsm_state1_blk;
wire    ap_ST_fsm_state2_blk;
wire    ap_ST_fsm_state3_blk;
reg    ap_block_state4_on_subcall_done;
reg    ap_ST_fsm_state4_blk;
wire    ap_ST_fsm_state5_blk;
wire    ap_ST_fsm_state6_blk;
wire    ap_ST_fsm_state7_blk;
reg    ap_ST_fsm_state8_blk;
wire    ap_ST_fsm_state9_blk;
wire    ap_ce_reg;

// power-on initialization
initial begin
#0 ap_CS_fsm = 9'd1;
#0 grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg = 1'b0;
#0 grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg = 1'b0;
end

cache_module_cacheMemory_RAM_AUTO_1R1W #(
    .DataWidth( 64 ),
    .AddressRange( 8 ),
    .AddressWidth( 3 ))
cacheMemory_U(
    .clk(ap_clk),
    .reset(ap_rst),
    .address0(cacheMemory_address0),
    .ce0(cacheMemory_ce0),
    .we0(cacheMemory_we0),
    .d0(cacheMemory_d0),
    .q0(cacheMemory_q0)
);

cache_module_cache_module_Pipeline_VITIS_LOOP_11_1 grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst),
    .ap_start(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start),
    .ap_done(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done),
    .ap_idle(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_idle),
    .ap_ready(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready),
    .newData_address0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0),
    .newData_ce0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0),
    .newData_q0(newData_q0),
    .or_ln11(or_ln11_reg_473),
    .cacheMemory_address0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0),
    .cacheMemory_ce0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0),
    .cacheMemory_we0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0),
    .cacheMemory_d0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0)
);

cache_module_cache_module_Pipeline_VITIS_LOOP_20_2 grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst),
    .ap_start(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start),
    .ap_done(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done),
    .ap_idle(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_idle),
    .ap_ready(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready),
    .bf_lshr_cast(tmp_2_reg_493),
    .trunc_ln7(trunc_ln7_reg_458),
    .cacheMemory_load_2_out(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out),
    .cacheMemory_load_2_out_ap_vld(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld),
    .cacheMemory_address0(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0),
    .cacheMemory_ce0(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0),
    .cacheMemory_q0(cacheMemory_q0),
    .ap_return(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return)
);

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state3)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= 1'b1;
        end else if ((grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready == 1'b1)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state7)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= 1'b1;
        end else if ((grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready == 1'b1)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state1))) begin
        add_ln9_reg_463[5 : 3] <= add_ln9_fu_240_p2[5 : 3];
        cacheMemory_addr_reg_468 <= zext_ln9_fu_256_p1;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state5)) begin
        cacheMemory_addr_1_reg_488 <= zext_ln15_fu_337_p1;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b1 == ap_CS_fsm_state8) & (grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld == 1'b1))) begin
        cacheMemory_load_2_loc_fu_110 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out;
    end
end

always @ (posedge ap_clk) begin
    if (((updateTagValid_read_read_fu_120_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        lshr_ln1_reg_478 <= {{add_ln15_fu_318_p2[5:3]}};
        trunc_ln15_2_reg_483 <= trunc_ln15_2_fu_334_p1;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state3)) begin
        or_ln11_reg_473[5 : 3] <= or_ln11_fu_290_p2[5 : 3];
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state8)) begin
        targetBlock_reg_498 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        tmp_2_reg_493 <= address[32'd29];
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state1)) begin
        trunc_ln7_reg_458 <= trunc_ln7_fu_212_p1;
    end
end

always @ (*) begin
    if ((ap_start == 1'b0)) begin
        ap_ST_fsm_state1_blk = 1'b1;
    end else begin
        ap_ST_fsm_state1_blk = 1'b0;
    end
end

assign ap_ST_fsm_state2_blk = 1'b0;

assign ap_ST_fsm_state3_blk = 1'b0;

always @ (*) begin
    if ((1'b1 == ap_block_state4_on_subcall_done)) begin
        ap_ST_fsm_state4_blk = 1'b1;
    end else begin
        ap_ST_fsm_state4_blk = 1'b0;
    end
end

assign ap_ST_fsm_state5_blk = 1'b0;

assign ap_ST_fsm_state6_blk = 1'b0;

assign ap_ST_fsm_state7_blk = 1'b0;

always @ (*) begin
    if ((grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done == 1'b0)) begin
        ap_ST_fsm_state8_blk = 1'b1;
    end else begin
        ap_ST_fsm_state8_blk = 1'b0;
    end
end

assign ap_ST_fsm_state9_blk = 1'b0;

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state9)) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b0))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state9)) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state6)) begin
        cacheMemory_address0 = cacheMemory_addr_1_reg_488;
    end else if ((1'b1 == ap_CS_fsm_state5)) begin
        cacheMemory_address0 = zext_ln15_fu_337_p1;
    end else if ((1'b1 == ap_CS_fsm_state2)) begin
        cacheMemory_address0 = cacheMemory_addr_reg_468;
    end else if ((1'b1 == ap_CS_fsm_state1)) begin
        cacheMemory_address0 = zext_ln9_fu_256_p1;
    end else if ((1'b1 == ap_CS_fsm_state8)) begin
        cacheMemory_address0 = grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0;
    end else if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_address0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0;
    end else begin
        cacheMemory_address0 = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state6) | (1'b1 == ap_CS_fsm_state2) | (1'b1 == ap_CS_fsm_state5) | ((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1)))) begin
        cacheMemory_ce0 = 1'b1;
    end else if ((1'b1 == ap_CS_fsm_state8)) begin
        cacheMemory_ce0 = grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0;
    end else if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_ce0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0;
    end else begin
        cacheMemory_ce0 = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state6)) begin
        cacheMemory_d0 = zext_ln17_fu_364_p1;
    end else if ((1'b1 == ap_CS_fsm_state2)) begin
        cacheMemory_d0 = zext_ln10_fu_285_p1;
    end else if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_d0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0;
    end else begin
        cacheMemory_d0 = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state2) | ((updateTagValid_read_read_fu_120_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state6)))) begin
        cacheMemory_we0 = 8'd15;
    end else if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_we0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0;
    end else begin
        cacheMemory_we0 = 8'd0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) & (targetBlock_reg_498 == 1'd0))) begin
        data_ap_vld = 1'b1;
    end else begin
        data_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state9) & (targetBlock_reg_498 == 1'd0))) begin
        dirty_ap_vld = 1'b1;
    end else begin
        dirty_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state9)) begin
        if ((targetBlock_reg_498 == 1'd1)) begin
            hit = 1'd0;
        end else if ((targetBlock_reg_498 == 1'd0)) begin
            hit = 1'd1;
        end else begin
            hit = 'bx;
        end
    end else begin
        hit = 'bx;
    end
end

always @ (*) begin
    if ((((1'b1 == ap_CS_fsm_state9) & (targetBlock_reg_498 == 1'd1)) | ((1'b1 == ap_CS_fsm_state9) & (targetBlock_reg_498 == 1'd0)))) begin
        hit_ap_vld = 1'b1;
    end else begin
        hit_ap_vld = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((updateDataValid_read_read_fu_114_p2 == 1'd0) & (1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end else if (((updateDataValid_read_read_fu_114_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            ap_NS_fsm = ap_ST_fsm_state3;
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            if (((updateTagValid_read_read_fu_120_p2 == 1'd0) & (1'b0 == ap_block_state4_on_subcall_done) & (1'b1 == ap_CS_fsm_state4))) begin
                ap_NS_fsm = ap_ST_fsm_state6;
            end else if (((updateTagValid_read_read_fu_120_p2 == 1'd1) & (1'b0 == ap_block_state4_on_subcall_done) & (1'b1 == ap_CS_fsm_state4))) begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state5 : begin
            ap_NS_fsm = ap_ST_fsm_state6;
        end
        ap_ST_fsm_state6 : begin
            ap_NS_fsm = ap_ST_fsm_state7;
        end
        ap_ST_fsm_state7 : begin
            ap_NS_fsm = ap_ST_fsm_state8;
        end
        ap_ST_fsm_state8 : begin
            if (((1'b1 == ap_CS_fsm_state8) & (grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state9;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state8;
            end
        end
        ap_ST_fsm_state9 : begin
            ap_NS_fsm = ap_ST_fsm_state1;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign add_ln15_fu_318_p2 = (shl_ln15_2_fu_310_p3 + shl_ln15_1_fu_299_p3);

assign add_ln9_fu_240_p2 = (shl_ln9_1_fu_232_p3 + shl_ln9_fu_220_p3);

assign and_ln_fu_271_p3 = {{tmp_3_fu_261_p4}, {2'd0}};

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state5 = ap_CS_fsm[32'd4];

assign ap_CS_fsm_state6 = ap_CS_fsm[32'd5];

assign ap_CS_fsm_state7 = ap_CS_fsm[32'd6];

assign ap_CS_fsm_state8 = ap_CS_fsm[32'd7];

assign ap_CS_fsm_state9 = ap_CS_fsm[32'd8];

always @ (*) begin
    ap_block_state4_on_subcall_done = ((updateDataValid_read_read_fu_114_p2 == 1'd1) & (grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done == 1'b0));
end

assign data = lshr_ln23_fu_403_p2[7:0];

assign dirty = cacheMemory_load_2_loc_fu_110[32'd1];

assign grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg;

assign grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start = grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg;

assign lshr_ln23_fu_403_p2 = cacheMemory_load_2_loc_fu_110 >> zext_ln23_fu_399_p1;

assign lshr_ln9_fu_246_p4 = {{add_ln9_fu_240_p2[5:3]}};

assign newData_address0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0;

assign newData_ce0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0;

assign or_ln10_fu_279_p2 = (32'd1 | and_ln_fu_271_p3);

assign or_ln11_fu_290_p2 = (6'd4 | add_ln9_reg_463);

assign or_ln16_fu_358_p2 = (tmp_fu_349_p4 | 32'd1);

assign shl_ln15_1_fu_299_p3 = {{trunc_ln15_fu_296_p1}, {5'd0}};

assign shl_ln15_2_fu_310_p3 = {{trunc_ln15_1_fu_307_p1}, {3'd0}};

assign shl_ln9_1_fu_232_p3 = {{trunc_ln9_1_fu_228_p1}, {3'd0}};

assign shl_ln9_fu_220_p3 = {{trunc_ln9_fu_216_p1}, {5'd0}};

assign tmp_1_fu_341_p3 = cacheMemory_q0[32'd31];

assign tmp_3_fu_261_p4 = {{cacheMemory_q0[31:2]}};

assign tmp_9_fu_380_p4 = {{address[31:30]}};

assign tmp_fu_349_p4 = {{{tmp_1_fu_341_p3}, {trunc_ln15_2_reg_483}}, {2'd0}};

assign trunc_ln15_1_fu_307_p1 = updateWay[2:0];

assign trunc_ln15_2_fu_334_p1 = newTag[28:0];

assign trunc_ln15_fu_296_p1 = updateSet[0:0];

assign trunc_ln7_fu_212_p1 = address[28:0];

assign trunc_ln9_1_fu_228_p1 = updateWay[2:0];

assign trunc_ln9_fu_216_p1 = updateSet[0:0];

assign updateDataValid_read_read_fu_114_p2 = updateDataValid;

assign updateTagValid_read_read_fu_120_p2 = updateTagValid;

assign zext_ln10_fu_285_p1 = or_ln10_fu_279_p2;

assign zext_ln15_fu_337_p1 = lshr_ln1_reg_478;

assign zext_ln17_fu_364_p1 = or_ln16_fu_358_p2;

assign zext_ln23_cast_fu_389_p4 = {{{{1'd1}, {tmp_9_fu_380_p4}}}, {3'd0}};

assign zext_ln23_fu_399_p1 = zext_ln23_cast_fu_389_p4;

assign zext_ln9_fu_256_p1 = lshr_ln9_fu_246_p4;

always @ (posedge ap_clk) begin
    add_ln9_reg_463[2:0] <= 3'b000;
    or_ln11_reg_473[2:0] <= 3'b100;
end

endmodule //cache_module
